import {DOMRenderer as $42h8L$DOMRenderer} from "dom-renderer";
import {autorun as $42h8L$autorun, reaction as $42h8L$reaction} from "mobx";
import {toCamelCase as $42h8L$toCamelCase, parseJSON as $42h8L$parseJSON, isHTMLElementClass as $42h8L$isHTMLElementClass, toHyphenCase as $42h8L$toHyphenCase, stringifyDOM as $42h8L$stringifyDOM, delegate as $42h8L$delegate} from "web-utility";


function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $e7ba231a1760d706$exports = {};

$parcel$export($e7ba231a1760d706$exports, "observer", function () { return $e7ba231a1760d706$export$b6ae1bc530f4c149; });
$parcel$export($e7ba231a1760d706$exports, "attribute", function () { return $e7ba231a1760d706$export$af4b9a83f4b00434; });
$parcel$export($e7ba231a1760d706$exports, "reaction", function () { return $e7ba231a1760d706$export$7203b476385689ae; });



function $e7ba231a1760d706$var$wrapFunction(func) {
    return (props)=>{
        var tree, renderer = new (0, $42h8L$DOMRenderer)();
        const disposer = (0, $42h8L$autorun)(()=>{
            const newTree = func(props);
            tree = tree ? renderer.patch(tree, newTree) : newTree;
        });
        const { unRef: unRef } = tree;
        tree.unRef = (node)=>(disposer(), unRef?.(node));
        return tree;
    };
}
const $e7ba231a1760d706$var$reactionMap = new WeakMap();
function $e7ba231a1760d706$var$wrapClass(Component) {
    class ObserverComponent extends Component {
        disposers = [];
        constructor(){
            super();
            const { update: update } = Object.getPrototypeOf(this);
            this["update"] = ()=>this.disposers.push((0, $42h8L$autorun)(()=>update.call(this)));
        }
        connectedCallback() {
            const names = this.constructor["observedAttributes"], reactions = $e7ba231a1760d706$var$reactionMap.get(this) || [];
            this.disposers.push(...names.map((name)=>(0, $42h8L$autorun)(()=>this.syncPropAttr(name))), ...reactions.map(({ expression: expression, effect: effect })=>(0, $42h8L$reaction)((reaction)=>expression(this, reaction), effect.bind(this))));
            super["connectedCallback"]?.();
        }
        disconnectedCallback() {
            for (const disposer of this.disposers)disposer();
            this.disposers.length = 0;
        }
        attributeChangedCallback(name, old, value) {
            this[(0, $42h8L$toCamelCase)(name)] = (0, $42h8L$parseJSON)(value);
            super["attributeChangedCallback"]?.(name, old, value);
        }
        syncPropAttr(name) {
            var value = this[(0, $42h8L$toCamelCase)(name)];
            if (!(value != null) || value === false) return this.removeAttribute(name);
            value = value === true ? name : value;
            if (typeof value === "object") {
                value = value.toJSON?.();
                value = typeof value === "object" ? JSON.stringify(value) : value;
            }
            super.setAttribute(name, value);
        }
    }
    return ObserverComponent;
}
function $e7ba231a1760d706$export$b6ae1bc530f4c149(func, _) {
    return (0, $42h8L$isHTMLElementClass)(func) ? $e7ba231a1760d706$var$wrapClass(func) : $e7ba231a1760d706$var$wrapFunction(func);
}
function $e7ba231a1760d706$export$af4b9a83f4b00434(_, { name: name, addInitializer: addInitializer }) {
    addInitializer(function() {
        const { constructor: constructor } = this;
        var names = constructor["observedAttributes"];
        if (!names) {
            names = [];
            Object.defineProperty(constructor, "observedAttributes", {
                configurable: true,
                get: ()=>names
            });
        }
        names.push((0, $42h8L$toHyphenCase)(name.toString()));
    });
}
function $e7ba231a1760d706$export$7203b476385689ae(expression) {
    return (effect, { addInitializer: addInitializer })=>addInitializer(function() {
            const reactions = $e7ba231a1760d706$var$reactionMap.get(this) || [];
            reactions.push({
                expression: expression,
                effect: effect
            });
            $e7ba231a1760d706$var$reactionMap.set(this, reactions);
        });
}


var $a56b113cc897a12f$exports = {};

$parcel$export($a56b113cc897a12f$exports, "component", function () { return $a56b113cc897a12f$export$d8556a2a8f973135; });
$parcel$export($a56b113cc897a12f$exports, "on", function () { return $a56b113cc897a12f$export$af631764ddc44097; });


const $a56b113cc897a12f$var$eventMap = new WeakMap();
function $a56b113cc897a12f$export$d8556a2a8f973135(meta) {
    return (Class, { addInitializer: addInitializer })=>{
        class RendererComponent extends Class {
            internals = this.attachInternals();
            renderer = new (0, $42h8L$DOMRenderer)();
            get root() {
                return this.internals.shadowRoot || this;
            }
            constructor(){
                super();
                if (meta.mode && !this.internals.shadowRoot) this.attachShadow(meta);
            }
            connectedCallback() {
                this.update();
                const { mode: mode } = meta;
                const renderChildren = !(mode != null);
                const { root: root } = this, events = $a56b113cc897a12f$var$eventMap.get(this) || [];
                for (const { type: type, selector: selector, handler: handler } of events){
                    if (renderChildren && /^:host/.test(selector)) console.warn(`[WebCell] DOM Event delegation of "${selector}" won't work if you don't invoke "this.attachShadow()" manually.`);
                    root.addEventListener(type, handler);
                }
                super["connectedCallback"]?.();
            }
            update() {
                const vNode = this.render?.();
                if (vNode) this.renderer.render(vNode, this.root);
            }
            disconnectedCallback() {
                const { root: root } = this, events = $a56b113cc897a12f$var$eventMap.get(this) || [];
                for (const { type: type, handler: handler } of events)root.removeEventListener(type, handler);
                super["disconnectedCallback"]?.();
            }
            emit(event, detail, { cancelable: cancelable, bubbles: bubbles, composed: composed } = {}) {
                return this.dispatchEvent(new CustomEvent(event, {
                    detail: detail,
                    cancelable: cancelable,
                    bubbles: bubbles,
                    composed: composed
                }));
            }
            toString() {
                return (0, $42h8L$stringifyDOM)(this.root);
            }
        }
        addInitializer(function() {
            globalThis.customElements?.define(meta.tagName, this, meta);
        });
        return RendererComponent;
    };
}
function $a56b113cc897a12f$export$af631764ddc44097(type, selector) {
    return (method, { addInitializer: addInitializer })=>addInitializer(function() {
            const events = $a56b113cc897a12f$var$eventMap.get(this) || [], handler = (0, $42h8L$delegate)(selector, method.bind(this));
            events.push({
                type: type,
                selector: selector,
                handler: handler
            });
            $a56b113cc897a12f$var$eventMap.set(this, events);
        });
}




export {$e7ba231a1760d706$export$b6ae1bc530f4c149 as observer, $e7ba231a1760d706$export$af4b9a83f4b00434 as attribute, $e7ba231a1760d706$export$7203b476385689ae as reaction, $a56b113cc897a12f$export$d8556a2a8f973135 as component, $a56b113cc897a12f$export$af631764ddc44097 as on};
//# sourceMappingURL=index.esm.js.map
